package txnsync.ejb;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.sql.DataSource;
import javax.transaction.Status;
import javax.transaction.Synchronization;
import javax.transaction.TransactionSynchronizationRegistry;

public class MySynchronization implements Synchronization {

	@Override
	public void beforeCompletion() {
		TransactionSynchronizationRegistry reg = (TransactionSynchronizationRegistry)TxnSyncUtil.lookupJNDI("java:comp/TransactionSynchronizationRegistry");
		
		// Transaction exists
		Object txnKey = reg.getTransactionKey();
		assert txnKey != null;
		
		// Transaction active
		int status = reg.getTransactionStatus();
		assert status == Status.STATUS_ACTIVE;
		
		// Lookup DataSource with global JNDI name. OK!
		DataSource ds = (DataSource)TxnSyncUtil.lookupJNDI("jdbc/phonebook");
		Connection conn = null;
		Statement stmt = null;
		ResultSet rs = null;
		try {
			try {
				// XAResource corresponding Connection isn't enlisted 
				conn = ds.getConnection();
				stmt = conn.createStatement();
				rs = stmt.executeQuery("select * from PHONEBOOK");
				while (rs.next()) {
				}
			}
			finally {
				if (rs != null)
					rs.close();
				if (stmt != null)
					stmt.close();
				if (conn != null)
					conn.close();
			}
		}
		catch (SQLException e) {
		}
	}

	@Override
	public void afterCompletion(int status) {
	}
}
